var dtSettings = {

  /* Assign preferences service to variable*/
  dtPrefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null),
  winMediator: Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator),
  showItems: new Array(),

  // Assign used element id's and used preferences to constants
  Consts: {
    IDS: {
      TEXT: ['back-history-textbox', 'forward-history-textbox'],
      CHECKBOX: ['select-tab-checkbox', 'tablib-enabled-checkbox', 'select-urlbar-checkbox', 'back-history-checkbox',
                 'forward-history-checkbox', 'scroll-position-checkbox', 'zoom-factor-checkbox', 'duptab-merge-windowclose',
                 'duptab-merge-windowclose-showmessage', 'duptab-context-showontab', 'duptab-context-showonpage',
                 'duptab-tab-context-showinsubmenu', 'duptab-content-context-showinsubmenu', 'duplicatetab-link-middleclick-checkbox',
                 'duplicatetab-link-modifierclick-checkbox', 'duplicatetab-backfw-middleclick-checkbox', 'duplicatetab-backfw-modifierclick-checkbox',
                 'duptab-merge-merge-popups', 'duptab-merge-placepopupnextto-opener'],
      RADIO: ['duptab-merge-radiogroup'],
      SHOWITEMS: ['duptab-tab-context-nosubmenu-showtab', 'duptab-tab-context-nosubmenu-showwindow',
                  'duptab-tab-context-nosubmenu-showdetach', 'duptab-tab-context-nosubmenu-showmerge',
                  'duptab-content-context-nosubmenu-showtab', 'duptab-content-context-nosubmenu-showwindow',
                  'duptab-content-context-nosubmenu-showdetach', 'duptab-content-context-nosubmenu-showmerge'],
      COLLAPSEBOXES: ['duptab-tab-context-submenu-vbox', 'duptab-content-context-submenu-vbox']
    },
    PREFS: {
      TEXT: ['duplicatetab.back-history.length', 'duplicatetab.forward-history.length'],
      BOOL: ['duplicatetab.newtab.focus', 'duplicatetab.tablib.enabled', 'duplicatetab.focus-urlbar', 'duplicatetab.back-history.enabled',
             'duplicatetab.forward-history.enabled', 'duplicatetab.scrollposition.enabled',
             'duplicatetab.zoomfactor.enabled', 'duplicatetab.merge.closeOnSelect', 'duplicatetab.merge.promptOnClose',
             'duplicatetab.showContextMenu.onTab', 'duplicatetab.showContextMenu.onContentArea',
             'duplicatetab.showContextMenu.inSubMenu', 'duplicatetab.showContextMenu.inContentSubMenu',
             'duplicatetab.link.middleclick.open_in_duplicate_tab', 'duplicatetab.link.modifierclick.open_in_duplicate_tab',
             'duplicatetab.bfhistory.middleclick.open_in_duplicate_tab', 'duplicatetab.bfhistory.modifierclick.open_in_duplicate_tab',
             'duplicatetab.merge.mergePopups', 'duplicatetab.merge.placePopupNextToOpener'],
      RADIO: ['duplicatetab.merge.mergeAllWindows'],
      SHOWITEMS: ['duplicatetab.showContextMenu.items']
    },
    DEFAULTS: {
      TEXT: [0, 0],
      BOOL: [true, false, true, true, true, true, true, true, true, true, false, true, true, false, false, false, false, true, false],
      RADIO: [false],
      SHOWITEMS: ["3333"]
    }
  },

  // function for easy getting preference
  getPreference: function(prefName, defaultVal)
  {
    var type = dtSettings.dtPrefs.getPrefType(prefName);
    switch (type) {
      case dtSettings.dtPrefs.PREF_INVALID:
        return defaultVal;
      case dtSettings.dtPrefs.PREF_STRING:
        return dtSettings.dtPrefs.getCharPref(prefName);
      case dtSettings.dtPrefs.PREF_INT:
        return dtSettings.dtPrefs.getIntPref(prefName);
      case dtSettings.dtPrefs.PREF_BOOL:
        return dtSettings.dtPrefs.getBoolPref(prefName);
    }
    return defaultVal;
  },

  /* Set values of checkboxes and textboxes to current preferences for extension */
  onLoad: function()
  {
    var i, j;
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[7]).addEventListener("CheckboxStateChange", dtSettings.setDisabledFirst, false);
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[9]).addEventListener("CheckboxStateChange", dtSettings.collapseContent, false);
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[10]).addEventListener("CheckboxStateChange", dtSettings.collapseContent, false);
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[17]).addEventListener("CheckboxStateChange", dtSettings.setDisabledSecond, false);
    for (i=0;i<dtSettings.Consts.PREFS.BOOL.length;i++) {
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[i]).checked = dtSettings.getPreference(dtSettings.Consts.PREFS.BOOL[i], dtSettings.Consts.DEFAULTS.BOOL[i]);
    }
    for (i=0;i<dtSettings.Consts.IDS.TEXT.length;i++) {
      document.getElementById(dtSettings.Consts.IDS.TEXT[i]).value = dtSettings.getPreference(dtSettings.Consts.PREFS.TEXT[i], dtSettings.Consts.DEFAULTS.TEXT[i]);
    }
    var menuItemsPref = dtSettings.getPreference(dtSettings.Consts.PREFS.SHOWITEMS[0], dtSettings.Consts.DEFAULTS.SHOWITEMS[0]);
    if (menuItemsPref.length == 3)
      menuItemsPref = menuItemsPref.substr(0,2) + "3" + menuItemsPref.substr(-1);
    for (i=0,j=4;i<4;i++,j++) {
      document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[i]).checked = Boolean(parseInt(menuItemsPref.charAt(i))%2);
      document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[j]).checked = Boolean(parseInt(menuItemsPref.charAt(i))>1);
    }
    document.getElementById(dtSettings.Consts.IDS.RADIO[0]).selectedIndex = (dtSettings.getPreference(dtSettings.Consts.PREFS.RADIO[0], dtSettings.Consts.DEFAULTS.RADIO[0]))? 0: 1;
    dtSettings.checkForTablib();
    dtSettings.checkForMac();
  },

  // check whether the choice should be present to open a new tab next to the original using tablib (http://mozilla.dorando.at)
  checkForTablib: function()
  {
    var tablibCheckBox1 = document.getElementById(dtSettings.Consts.IDS.CHECKBOX[1]);
    var tablibCheckBox2 = document.getElementById(dtSettings.Consts.IDS.CHECKBOX[17]);
    var latestWindow = dtSettings.winMediator.getMostRecentWindow('navigator:browser');
    if (latestWindow.gBrowser.moveTabTo == undefined) {
      tablibCheckBox1.collapsed = true;
      tablibCheckBox2.collapsed = true;
    }
    else {
      tablibCheckBox1.collapsed = false;
      tablibCheckBox2.collapsed = false;
      if (latestWindow.duplicateTab.tablibPref && dtSettings.getPreference(latestWindow.duplicateTab.tablibPref, false)) {
        tablibCheckBox1.disabled = true;
        tablibCheckBox1.checked = true;
      }
      else
        tablibCheckBox1.removeAttribute('disabled');
    }
  },

  checkForMac: function()
  {
    var latestWindow = this.winMediator.getMostRecentWindow('navigator:browser');
    if (latestWindow.navigator.appVersion.indexOf("Mac") == -1)
      return;

    var macElements = document.getElementsByAttribute("mac", "true");
    for (var i = 0; i < macElements.length; i++) {
      var newlabel = macElements[i].getAttribute("maclabel");
      macElements[i].setAttribute("label", newlabel);
    }
  },

  setDisabledFirst: function()
  {
    // change disabled attribute of checkbox to allow for message on window close whether window is closed or not
    if (document.getElementById(dtSettings.Consts.IDS.CHECKBOX[7]).getAttribute('checked') != 'true') {
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[8]).setAttribute('disabled', 'true');
    }
    else if (document.getElementById(dtSettings.Consts.IDS.CHECKBOX[8]).getAttribute('disabled') == 'true') {
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[8]).removeAttribute('disabled');
    }
  },

  setDisabledSecond: function()
  {
    if (document.getElementById(dtSettings.Consts.IDS.CHECKBOX[17]).getAttribute('checked') != 'true')
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[18]).setAttribute('disabled', 'true');
    else if (document.getElementById(dtSettings.Consts.IDS.CHECKBOX[18]).getAttribute('disabled') == 'true')
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[18]).removeAttribute('disabled');
  },

  collapseContent: function(event)
  {
    switch (event.originalTarget.id)
    {
      case dtSettings.Consts.IDS.CHECKBOX[9]:
        document.getElementById(dtSettings.Consts.IDS.COLLAPSEBOXES[0]).collapsed = !event.originalTarget.checked;
        break;
      case dtSettings.Consts.IDS.CHECKBOX[10]:
        document.getElementById(dtSettings.Consts.IDS.COLLAPSEBOXES[1]).collapsed = !event.originalTarget.checked;
        break;
    }
    sizeToContent();
  },

  // Set values of checkboxes and textboxes to default preferences for extension
  setDefaults: function()
  {
    // lock all prefs so defaults are selected
    var i, prefs = dtSettings.Consts.PREFS;
    for (prop in prefs) {
      for (i=0; i<prefs[prop].length; i++) {
        dtSettings.dtPrefs.lockPref(prefs[prop][i]);
      }
    }

    // change all values to defaults by loading with default prefs
    dtSettings.onLoad();

    // unlock all prefs so prefs can be changed again
    for (prop in prefs) {
      for (i=0; i<prefs[prop].length; i++) {
        dtSettings.dtPrefs.unlockPref(prefs[prop][i]);
      }
    }
  },

  /* change preferences to user selected values */
  onAccept: function()
  {
    var i, j, showItemsText = "";
    for (i=0;i<dtSettings.Consts.PREFS.BOOL.length;i++) {
      dtSettings.dtPrefs.setBoolPref(dtSettings.Consts.PREFS.BOOL[i], document.getElementById(dtSettings.Consts.IDS.CHECKBOX[i]).checked);
    }
    for (i=0;i<dtSettings.Consts.IDS.TEXT.length;i++) {
      var numValue = parseInt(document.getElementById(dtSettings.Consts.IDS.TEXT[i]).value);
      var textValue = isNaN(numValue)?0:numValue;
      dtSettings.dtPrefs.setIntPref(dtSettings.Consts.PREFS.TEXT[i], textValue);
    }
    for (i=0; i<4; i++) {
      j=i+4;
      var num1 = (document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[i]).checked)?1:0;
      var num2 = (document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[j]).checked)?2:0;
      showItemsText += (num1+num2).toString();
    }
    dtSettings.dtPrefs.setCharPref(dtSettings.Consts.PREFS.SHOWITEMS[0], showItemsText);
    dtSettings.dtPrefs.setBoolPref(dtSettings.Consts.PREFS.RADIO[0], (!Boolean(document.getElementById(dtSettings.Consts.IDS.RADIO[0]).selectedIndex)));
  },

  onCancel: function() {
  }

}
